local button = CreateFrame("Button", "SmartRocksButton", UIParent, "SecureActionButtonTemplate")
button:SetHeight(30)
button:SetWidth(30)
button:SetPoint("CENTER")
button:EnableMouse(true)
button:SetMovable(true)
button:SetScript("OnMouseDown", function(self) if IsModifierKeyDown() then self:StartMoving() end end)
button:SetScript("OnMouseUp", function(self) self:StopMovingOrSizing() end)
button:SetScript("OnDoubleClick", function(self) if IsModifierKeyDown() then self:Hide() SmartRocksHidden = 1 end end)
button:SetAttribute("type", "macro")
button:SetAttribute("macrotext", "/use item:36892")
local icon = button:CreateTexture("SmartRocksButtonIcon")
icon:SetAllPoints()
icon:SetTexture([[Interface\Icons\INV_Stone_04]])
icon:SetDesaturated(true)
SmartRocksHidden = 0

button:RegisterEvent("CHAT_MSG_LOOT")
button:RegisterEvent("UNIT_SPELLCAST_SUCCEEDED")
button:RegisterEvent("PLAYER_ENTERING_WORLD")
button:SetScript("OnEvent", function(self, event, ...)
	if event == "CHAT_MSG_LOOT" then
		local message = ...
		if InCombatLockdown() then
			return
		end
	
		if not strfind(message, "Healthstone") then
			return
		else
			local itemID = message:match("item:(%d+):")
			if itemID then
				button:SetAttribute("macrotext", "/use item:"..itemID)
			else
				print("SmartRocks was unable to configure your macro for some reason.")
				return
			end
			icon:SetDesaturated(false)
			if SmartRocksHidden == 1 then
				local index
				for i = 1, 18 do
					if GetMacroInfo(i) == "SmartRock" then
						index = i
						break
					end
				end
				if index then
					EditMacro(index, nil, nil, "#showtooltip item:"..itemID.."\n/click SmartRocksButton")
				end
			end
		end
	elseif event == "UNIT_SPELLCAST_SUCCEEDED" then
		local player, spell = ...
		if player ~= "player" or not strfind(spell, "Healthstone") then
			return
		else
			icon:SetDesaturated(true)
		end
	elseif event == "PLAYER_ENTERING_WORLD" then
		if SmartRocksHidden == 1 then
			SmartRocksButton:Hide()
		end
	end
end)